unit Unit7;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm7 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    palette: TImage;
    ColorDialog1: TColorDialog;
    Button1: TButton;
    Label1: TLabel;
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure paletteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form7: TForm7;

implementation

{$R *.dfm}

procedure fill_region(rect:Trect; canvas:Tcanvas; find_color,fill_color:Tcolor; x,y:integer);
begin
if (x<rect.Left)or(x>rect.Right) then exit;
if (y<rect.Top)or(y>rect.Bottom) then exit;

if (canvas.pixels[x,y]=find_color)and(canvas.pixels[x,y]<>fill_color) then
begin
canvas.pixels[x,y]:=fill_color;
fill_region(rect,canvas,find_color,fill_color,x+1,y);
fill_region(rect,canvas,find_color,fill_color,x-1,y);
fill_region(rect,canvas,find_color,fill_color,x,y+1);
fill_region(rect,canvas,find_color,fill_color,x,y-1);
fill_region(rect,canvas,find_color,fill_color,x+1,y+1);
fill_region(rect,canvas,find_color,fill_color,x-1,y+1);
fill_region(rect,canvas,find_color,fill_color,x+1,y-1);
fill_region(rect,canvas,find_color,fill_color,x-1,y-1);
end;

end;


procedure TForm7.Button1Click(Sender: TObject);
begin
image1.Canvas.CopyRect(bounds(0,0,image1.Width,image1.Height),image2.Canvas,bounds(0,0,image2.Width,image2.Height));
end;

procedure TForm7.FormCreate(Sender: TObject);
begin
  palette.Canvas.Brush.Color:=form7.Color;
  palette.Canvas.Rectangle(1,1,palette.Width-2,palette.Height-2);
  button1.Click;
end;

procedure TForm7.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
fill_region(image1.ClientRect,image1.Canvas,image1.Canvas.Pixels[x,y],palette.Canvas.Pixels[10,10],x,y);
end;

procedure TForm7.paletteClick(Sender: TObject);
begin
if colordialog1.Execute then
begin
  palette.Canvas.Brush.Color:=colordialog1.Color;
  palette.Canvas.Rectangle(1,1,palette.Width-2,palette.Height-2);
end;
end;

end.
